unit hiIf_elsePer;

interface

uses Kol,Share,Debug;

type
  THIIf_elsePer = class(TDebug)
   private
   public
    _prop_Percent:integer;
    _prop_Op1,_prop_Op2:String;

    _data_Op1:THI_Event;
    _data_Op2:THI_Event;
    _event_onFalse:THI_Event;
    _event_onTrue:THI_Event;
    _event_Percent:THI_Event;

    procedure _work_doCompare(var _Data:TData; Index:word);
  end;

implementation


procedure THIIf_elsePer._work_doCompare;
var
   dt:TData;
   sOp1,sOp2:String;
   i,iMin,iMax,iSame:integer;
begin
   dt:=_Data;
   sOp1 :=  ReadString(_Data,_data_Op1,_prop_Op1); 
   sOp2 :=  ReadString(_Data,_data_Op2,_prop_Op2);
   if (sOp1='') and (sOp2='') then exit;
   iMax := Max(Length(sOp1), Length(sOp2));
   iMin := Min(Length(sOp1), Length(sOp2));
   iSame := 0;
     for i := 1 to iMin do if sOp1[i] = sOp2[i] then Inc(iSame);
     iSame := Trunc((iSame / iMax) * 100);
      _hi_onEvent(_event_Percent,iSame);  
    if iSame >= _prop_Percent then
       _hi_CreateEvent(_Data,@_event_onTrue, dt)
    else
       _hi_CreateEvent(_Data,@_event_onFalse,dt);
end;

end.
